<?php

/**
 * @package   	JCE
 * @copyright 	Copyright (C) 2014 FLEXIcontent project. All rights reserved.
 * @license   	GNU/GPL 2 or later - http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
 * @author     	ggppdk
 *
 * Flexicontentlinks is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 *
 * Based on "joomlalinks" found in JCE's core distribution, by Ryan Demmer
 */
defined( '_WF_EXT' ) or die( 'RESTRICTED' );

class FlexicontentlinksTags extends JObject {

	var $_option = 'com_flexicontent_tags';
	
	/**
	* Constructor activating the default information of the class
	*
	* @access	protected
	*/
	public function __construct($options = array()) {
        
	}

	/**
	 * Returns a reference to a editor object
	 *
	 * This method must be invoked as:
	 * 		<pre>  $browser =JContentEditor::getInstance();</pre>
	 *
	 * @access	public
	 * @return	JCE  The editor object.
	 * @since	1.5
	 */
	public static function getInstance() {
		static $instance;

		if ( !is_object( $instance ) ){
			$instance = new FlexicontentlinksTags();
		}
		return $instance;
	}
	
	public function getOption() {
		return $this->_option;
	}
	
	public function getList() {
		$wf = WFEditorPlugin::getInstance();
		
		if ($wf->checkAccess('links.flexicontentlinks.tags', 1)) {
			return  '<li id="index.php?option=com_flexicontent_tags&view=tags"><div class="tree-row"><div class="tree-image"></div><span class="folderflexitags nolink"><a href="javascript:;">' . JText::_('FLEXI_TAGS') . '</a></span></div></li>';
		}
	}
	
	public function getLinks($args) {		
		$wf = WFEditorPlugin::getInstance();
		$view = isset($args->view) ? $args->view : '';
		if ($view && $view!='tags') {return array();}
		
		$items 	= array();
		
    if (!defined('JPATH_PLATFORM')) require_once(JPATH_SITE . '/includes/application.php');
		require_once(JPATH_SITE . '/components/com_flexicontent/helpers/route.php');
		
		$db = JFactory::getDBO();
		$query	= $db->getQuery(true);
		$query->clear();
		$query->select('t.name, t.id, CASE WHEN CHAR_LENGTH(t.alias) THEN CONCAT_WS(\':\', t.id, t.alias) ELSE t.id END as slug ');
		$query->from('#__flexicontent_tags AS t ');
		$query->where('t.published = 1 ');
		$query->order('t.name ASC');
		$db->setQuery($query);
		$tags = $db->loadObjectList();
		
		foreach ($tags as $tag) {
			$url = $id = FlexicontentHelperRoute::getTagRoute($tag->slug);
			$items[] = array(
				'id'		=>	$id,
				'url'   => self::route($url),
				'name'		=>	$tag->name,
				'class'		=>	'fileflexitag'
			);
		}
		
		return $items;
	}
	
	private static function route($url) {
		$wf = WFEditorPlugin::getInstance();
		
		if ($wf->getParam('links.joomlalinks.sef_url', 0)) {
			$url = WFLinkExtension::route($url);
		}
		
		return $url;
	}
}
?>